;###############################################################################
;
;	PIC GUITER TUNER
;

;-------------------------------------------------------------------------------
;
;	إå
;
		include	my16f84.h
		.16f84				; PIC16F84

;-------------------------------------------------------------------------------
;
;	ϥݡ
;
MYTRISA		equ	00000000b		; (0:, 1:())
MYTRISB		equ	00100000b
LEDR		equ	   4			; LED-Red
SWITCH		equ	  5			; SWITCH
LEDB		equ	 6			; LED-Blue
SOUND		equ	7			; SOUND

;-------------------------------------------------------------------------------
;
;	EEPROM
;
		eeorg	0			; EEDATA

;-------------------------------------------------------------------------------
;
;	ꥻ
;
		org	20h			; ޥå

aTemp		ds	1			; A쥸
sTemp		ds	1			; STATUS쥸

toneMode	ds	1
toneWaitM	ds	1
toneWaitS1	ds	1
toneWaitS2	ds	1
toneWaitS3	ds	1
toneWaitS4	ds	1

bufPortB	ds	1

waitCntS	ds	1			; Ԥѥ
waitCntM	ds	1
waitCntL	ds	1

;-------------------------------------------------------------------------------
;
;	ץॻ
;
		org	00h			; ꥻåȥ٥
		JP	start

;-------------------------------------------------------------------------------
;
;	߽
;
		org	04h			; ߥ٥
isrStart
;		LD	(aTemp),A		; 쥸
;		SWAP	(STATUS)>A
;		RES	RP0, (STATUS)		; Х0
;		LD	(sTemp),A
;isrTimer
;		BIT	T0IF, (INTCON)		; ȯװTimer0
;		JP	Z, isrEnd
;		RES	T0IF, (INTCON)		; ȯե饰ߤ()
;
;		INC	(mSec)			; 1ms++
;isrEnd
;		SWAP	(sTemp)>A		; 쥸
;		LD	(STATUS),A
;		SWAP	(aTemp)
;		SWAP	(aTemp)>A
		RETI

;-------------------------------------------------------------------------------
;
;	å׽
;
start
		RES	RP0, (STATUS)		; Х0

		CLR	(PORTA)			; ݡȤ
		CLR	(PORTB)			; ݡȤ

		SET	RP0, (STATUS)		; Х1

		LD	A, MYTRISA		; :11111111b
		LD	(TRISA), A		; ݡ
		LD	A, MYTRISB
		LD	(TRISB), A
timerSet
		CLR	(WDT)			; åɥåޡץꥹ饯ꥢ

		LD	A, 00000111b		; :11111111b
		LD	(OPTION), A		; 7:PORTBץ륢å(0:Ѥ)
						; 6:GP2ߥݡѲ(0:Ω)
						; 5:TMR0åӥå(0:)
						; 4:GP2ѲTMR0ûߥ(0:Ω)
						; 3:ץꥹƥӥå(0:TMR0)
						; 2~0ץꥹ졼ӥå(111:1/256)

		RES	RP0, (STATUS)		; Х0

		CLR	(TMR0)			; ޥꥢ
intStart
		LD	A, 00000000b		; :00000000b
		LD	(INTCON), A		; 7:Хߥ֥͡
						; 6:EE饤ȴλߥ֥͡
						; 5:TMR0Сեߥ֥͡
						; 4:RB0/INTߥ֥͡
						; 3:RBݡѲߥ֥͡

;--------------------------------------------------------------------------------
;
;	ᥤ
;
;calibration					; åΥ֥졼(20)
;		SET	LEDR, (PORTB)
;		LD	A, 6			; 8MHz6ꤹȡ
;		CALL	WAITnx3p5us		; 2Ԥ 6 x 1.5 + 2.5 = 11.5us 
;		LD	A, 200			; 8MHz4ꤹȡ
;		CALL	WAITnx01sm25us		; 2Ԥ 200 x 50ms - 12.5us 񤹤
;
;		LD	A, 233			; 1.005830Ψʬ
;		CALL	WAITnx500m35us
;		LD	A, 43
;		CALL	WAITnx3p5us
;
;		RES	LEDR, (PORTB)
;		LD	A, 6			; 8MHz6ꤹȡ
;		CALL	WAITnx3p5us		; 2Ԥ 6 x 1.5 + 2.5 = 11.5us 
;		LD	A, 200			; 8MHz10ꤹȡ
;		CALL	WAITnx01sm25us		; 2Ԥ 200 x 50ms - 12.5us 񤹤
;
;		LD	A, 233			; 1.005830Ψʬ
;		CALL	WAITnx500m35us
;		LD	A, 43
;		CALL	WAITnx3p5us
;
;		JP	calibration

changeTone0
		LD	A, 7
		LD	(toneMode), A
changeTone
		DEC	(toneMode)
		JP	Z, changeTone0

		LD	A, 5
		CALL	WAITnx01sm25us		; 2Ԥ 5 x 50ms - 12.5us 񤹤

		LD	A, (toneMode)
		CALL	getFreqM
		LD	(toneWaitM), A
		LD	A, (toneMode)
		CALL	getFreqS1
		LD	(toneWaitS1), A
		LD	A, (toneMode)
		CALL	getFreqS2
		LD	(toneWaitS2), A
		LD	A, (toneMode)
		CALL	getFreqS3
		LD	(toneWaitS3), A
		LD	A, (toneMode)
		CALL	getFreqS4
		LD	(toneWaitS4), A
main
		LD	A, (bufPortB)
		OR	A, 10010000B		; SOUND ON & Red-LED ON
		LD	(bufPortB), A
		LD	(PORTB), A

		LD	A, (toneWaitM)
		CALL	WAITnx3p5us
		LD	A, (toneWaitS1)
		CALL	WAITnx3p5us

		LD	A, (bufPortB)
		AND	A, 11101111B		; Red-LED OFF
		LD	(bufPortB), A
		LD	(PORTB), A

		LD	A, (toneWaitM)
		CALL	WAITnx3p5us
		LD	A, (toneWaitS2)
		CALL	WAITnx3p5us

		LD	A, (bufPortB)
		AND	A, 01111111B		; SOUND OFF
		LD	(bufPortB), A
		LD	(PORTB), A

		LD	A, (toneWaitM)
		CALL	WAITnx3p5us
		LD	A, (toneWaitS3)
		CALL	WAITnx3p5us
		LD	A, (toneWaitM)
		CALL	WAITnx3p5us
		LD	A, (toneWaitS4)
		CALL	WAITnx3p5us

		NOP
		NOP
		NOP
;----
		LD	A, (bufPortB)
		OR	A, 11000000B		; SOUND ON & Blue-LED ON
		LD	(bufPortB), A
		LD	(PORTB), A

		LD	A, (toneWaitM)
		CALL	WAITnx3p5us
		LD	A, (toneWaitS1)
		CALL	WAITnx3p5us

		LD	A, (bufPortB)
		AND	A, 10111111B		; Blue-LED OFF
		LD	(bufPortB), A
		LD	(PORTB), A

		LD	A, (toneWaitM)
		CALL	WAITnx3p5us
		LD	A, (toneWaitS2)
		CALL	WAITnx3p5us

		LD	A, (bufPortB)
		AND	A, 01111111B		; SOUND OFF
		LD	(bufPortB), A
		LD	(PORTB), A

		LD	A, (toneWaitM)
		CALL	WAITnx3p5us
		LD	A, (toneWaitS3)
		CALL	WAITnx3p5us
		LD	A, (toneWaitM)
		CALL	WAITnx3p5us
		LD	A, (toneWaitS4)
		CALL	WAITnx3p5us

		NOP
		NOP
		NOP
;----
		LD	A, (bufPortB)
		OR	A, 10000000B		; SOUND ON
		LD	(bufPortB), A
		LD	(PORTB), A

		LD	A, (toneWaitM)
		CALL	WAITnx3p5us
		LD	A, (toneWaitS1)
		CALL	WAITnx3p5us

		LD	A, (bufPortB)
		AND	A, 11111111B
		LD	(bufPortB), A
		LD	(PORTB), A

		LD	A, (toneWaitM)
		CALL	WAITnx3p5us
		LD	A, (toneWaitS2)
		CALL	WAITnx3p5us

		LD	A, (bufPortB)
		AND	A, 01111111B		; SOUND OFF
		LD	(bufPortB), A
		LD	(PORTB), A

		LD	A, (toneWaitM)
		CALL	WAITnx3p5us
		LD	A, (toneWaitS3)
		CALL	WAITnx3p5us
		LD	A, (toneWaitM)
		CALL	WAITnx3p5us
		LD	A, (toneWaitS4)
		CALL	WAITnx3p5us

		NOP
		NOP
		NOP
;----
		LD	A, (bufPortB)
		OR	A, 10000000B		; SOUND ON
		LD	(bufPortB), A
		LD	(PORTB), A

		LD	A, (toneWaitM)
		CALL	WAITnx3p5us
		LD	A, (toneWaitS1)
		CALL	WAITnx3p5us

		LD	A, (bufPortB)
		AND	A, 11111111B
		LD	(bufPortB), A
		LD	(PORTB), A

		LD	A, (toneWaitM)
		CALL	WAITnx3p5us
		LD	A, (toneWaitS2)
		CALL	WAITnx3p5us

		LD	A, (bufPortB)
		AND	A, 01111111B		; SOUND OFF
		LD	(bufPortB), A
		LD	(PORTB), A

		LD	A, (toneWaitM)
		CALL	WAITnx3p5us
		LD	A, (toneWaitS3)
		CALL	WAITnx3p5us
		LD	A, (toneWaitM)
		CALL	WAITnx3p5us
		LD	A, (toneWaitS4)
		CALL	WAITnx3p5us

		BIT	SWITCH, (PORTB)
		JP	NZ, main
;----
		JP	changeTone

;--------------------------------------------------------------------------------
;
;	ȿ
;
getFreqM	ADD	(PCL), A
		NOP
		RET	100>A
		RET	150>A
		RET	200>A
		RET	250>A
		RET	250>A
		RET	253>A

getFreqS1	ADD	(PCL), A
		NOP
		RET	23>A
		RET	16>A
		RET	10>A
		RET	31>A
		RET	127>A
		RET	251>A

getFreqS2	ADD	(PCL), A
		NOP
		RET	23>A
		RET	15>A
		RET	9>A
		RET	31>A
		RET	127>A
		RET	251>A

getFreqS3	ADD	(PCL), A
		NOP
		RET	22>A
		RET	15>A
		RET	9>A
		RET	31>A
		RET	126>A
		RET	251>A

getFreqS4	ADD	(PCL), A
		NOP
		RET	22>A
		RET	15>A
		RET	9>A
		RET	31>A
		RET	126>A
		RET	251>A

;--------------------------------------------------------------------------------
;
;	Ԥ()
;
;		LD	A, 10			; 4MHz10ꤹȡ
;		CALL	WAITnx3p5us		; 2Ԥ 10 x 3 + 5 = 35us 
;
WAITnx3p5us
		LD	(waitCntS), A
WAITnx3p5us1
		DJNZ	(waitCntS), WAITnx3p5us1
		RET

;--------------------------------------------------------------------------------
;
;	Ԥ()
;
;		LD	A, 200			; 4MHz0.1äξ硢200ꤹȡ
;		CALL	WAITnx500m35us		; 2Ԥ 200 x 500 - 35 = 99.965ms 񤹤
;
WAITnx500m35us
		LD	(waitCntM), A
		JP	WAITnx500m35us2
WAITnx500m35us1	NOP
		LD	A, 12			;  12 x 3 + 5 =  41us
		CALL	WAITnx3p5us		;		λԤ
WAITnx500m35us2	LD	A, 150			; 150 x 3 + 5 = 455us
		CALL	WAITnx3p5us		;		λԤ
		DJNZ	(waitCntM), WAITnx500m35us1
		RET

;--------------------------------------------------------------------------------
;
;	Ԥ()
;
;		LD	A, 10			; 4MHz1äξ硢10ꤹȡ
;		CALL	WAITnx01sm25us		; 2Ԥ 10 x 100ms - 25us 񤹤
;
WAITnx01sm25us
		LD	(waitCntL), A
		JP	WAITnx01sm25us2
WAITnx01sm25us1	LD	A, 9
		CALL	WAITnx3p5us
WAITnx01sm25us2	LD	A, 200
		CALL	WAITnx500m35us
		DJNZ	(waitCntL), WAITnx01sm25us1
		RET

